
<cfcomponent
	output="false"
	hint="I define the application and set up event handlers.">
	
	<!--- Define the application. --->
	<cfset THIS.Name = "KinkyTwits {#Hash( GetCurrentTemplatePath() )#}" />
	<cfset THIS.ApplicationTimeout = CreateTimeSpan( 0, 8, 0, 0 ) />
	<cfset THIS.SessionManagement = false />
	
	<!--- Define the page request settings. --->
	<cfsetting
		requesttimeout="20"
		showdebugoutput="false"
		/>
		
		
	<cffunction 
		name="OnApplicationStart" 
		access="public" 
		returntype="boolean" 
		output="false" 
		hint="I run when the application boots up or is manually reset.">
	
		<!--- Define the local scope. --->
		<cfset var LOCAL = {} />
		
		<!--- Clear the application scope in case we are manually resetting. --->
		<cfset StructClear( APPLICATION ) />
		
		<!--- Set the twitter login. --->	
		<cfset APPLICATION.Twitter = {
			Username = "XXXX",
			Password = "XXXX"
			} />
			
		<!--- Include the local configuration. --->
		<cfinclude template="config.cfm" />
			
		
		<!--- Check to see if username and password were updated. --->
		<cfif (APPLICATION.Twitter.Username EQ "")>
		
			<!--- Throw config error. --->
			<cfthrow
				type="KinkyTwits.OnApplicationStart.ConfigError"
				message="Your username and password have not been entered."
				detail="Your username and password have not been properly entered in the CONFIG.CFM file in the root folder."
				/>
		
		</cfif>
		
			
		<!--- Get the data folder. --->
		<cfset APPLICATION.DataFolder = (GetDirectoryFromPath( GetCurrentTemplatePath() ) & "data\") />
			
		<!--- Get the logging folder. --->
		<cfset APPLICATION.LoggingFolder = (APPLICATION.DataFolder & "logging\") />
		
		<!--- Create and cache the factory object. --->
		<cfset APPLICATION.Factory = CreateObject( "component", "cfc.Factory" ).Init(
			DataFolder = APPLICATION.DataFolder,
			LoggingFolder = APPLICATION.LoggingFolder,
			Username = APPLICATION.Twitter.Username,
			Password = APPLICATION.Twitter.Password
			) />
		
		<!--- Return out. --->	
		<cfreturn true />
	</cffunction>
	
	
	<cffunction 
		name="OnRequestStart" 
		access="public" 
		returntype="boolean" 
		output="false" 
		hint="I run when a request is made.">
		
		<!--- Check to see if we are manually resetting. --->
		<cfif StructKeyExists( URL, "reset" )>
			
			<!--- Manually reset application. --->
			<cfset THIS.OnApplicationStart() />
		
		</cfif>
		
		<!--- Return out. --->
		<cfreturn true />
	</cffunction>
		
</cfcomponent>