
<cfcomponent
	output="false"
	hint="I provide base API functionality.">
	
	
	<!--- Store a reference to the application factory. --->
	<cfset VARIABLES.Factory = APPLICATION.Factory />
	
	
	<cffunction 
		name="HandleAPIError" 
		access="public" 
		returntype="struct" 
		output="false" 
		hint="I handle a any errors and populate the API response an necessary.">
	
		<!--- Define arguments. --->
		<cfargument 
			name="Response" 
			type="struct" 
			required="true" 
			hint="I am the response object."
			/>
			
		<cfargument 
			name="Exception" 
			type="any" 
			required="true" 
			hint="I am the exception object (CFCATCH scope)."
			/>
		
		<!--- Flag request as failure. --->
		<cfset ARGUMENTS.Response.Success = false />
		
		<!--- Store error messages. --->
		<cfset ArrayAppend(
			ARGUMENTS.Response.Errors,
			ARGUMENTS.Exception.Message						
			) />
			
		<!--- Store error detail. --->
		<cfset ArrayAppend(
			ARGUMENTS.Response.Errors,
			ARGUMENTS.Exception.Detail
			) />
		
		<!--- Reset data. --->
		<cfset ARGUMENTS.Response.Data = "" />
		
		<!--- Log error. --->
		<cfset VARIABLES.Factory.Get( "LoggingService" ).LogData(
			"API Error",
			ARGUMENTS.Exception,
			"api_error"
			) />
		
		<!--- Return update response. --->
		<cfreturn ARGUMENTS.Response />
	</cffunction>
		
	
	<cffunction 
		name="NewAPIResponse" 
		access="public" 
		returntype="struct" 
		output="false" 
		hint="I create a new API response object.">
		
		<!--- Define the local scope. --->
		<cfset var LOCAL = {} />
		
		<!--- Create a new reponse. --->
		<cfset LOCAL.Response = {
			Success = true,
			Errors = [],
			Data = ""
			} />
		
		<!--- Return response. --->
		<cfreturn LOCAL.Response />
	</cffunction>
	
</cfcomponent>