
<cfcomponent
	extends="BaseAPI"
	output="false"
	hint="I provide the Friends API.">
	
	
	<cffunction 
		name="SnoozeFriend" 
		access="remote" 
		returntype="struct" 
		returnformat="json"
		output="false" 
		hint="I snooze a friend for an additional hour.">
		
		<!--- Define arguments. --->
		<cfargument 
			name="ID" 
			type="numeric" 
			required="true" 
			hint="I am the internal ID of the friend being snoozed."
			/>
		
		<!--- Define the local scope. --->
		<cfset var LOCAL = {} />
		
		<!--- Create a new response. --->
		<cfset LOCAL.Response = NewAPIResponse() />

		<cftry>
		
			<!--- Snooze the friend. --->
			<cfset VARIABLES.Factory.Get( "FriendService" ).Snooze( ARGUMENTS.ID ) />
			
			<!--- Create the response object. --->
			<cfset LOCAL.Response.Data = true />
		
			<!--- Catch any exceptions. --->
			<cfcatch>
				
				<!--- Update response. --->
				<cfset THIS.HandleAPIError( LOCAL.Response, CFCATCH ) />
				
			</cfcatch>			
		</cftry>	
		
		<!--- Return response. --->
		<cfreturn LOCAL.Response />
	</cffunction>
	
	
	<cffunction 
		name="UnsnoozeFriend" 
		access="remote" 
		returntype="struct" 
		returnformat="json"
		output="false" 
		hint="I unsnooze a friend.">
		
		<!--- Define arguments. --->
		<cfargument 
			name="ID" 
			type="numeric" 
			required="true" 
			hint="I am the internal ID of the friend being unsnoozed."
			/>
		
		<!--- Define the local scope. --->
		<cfset var LOCAL = {} />
		
		<!--- Create a new response. --->
		<cfset LOCAL.Response = NewAPIResponse() />
	
		<cftry>
			
			<!--- Unsnooze the friend. --->
			<cfset VARIABLES.Factory.Get( "FriendService" ).Unsnooze( ARGUMENTS.ID ) />
			
			<!--- Create the response object. --->
			<cfset LOCAL.Response.Data = true />
		
			<!--- Catch any exceptions. --->
			<cfcatch>
				
				<!--- Update response. --->
				<cfset THIS.HandleAPIError( LOCAL.Response, CFCATCH ) />
			
			</cfcatch>			
		</cftry>	
		
		<!--- Return response. --->
		<cfreturn LOCAL.Response />
	</cffunction>
	
</cfcomponent>