
<cfcomponent
	extends="BaseAPI"
	output="false"
	hint="I provide Status API.">
	
	
	<cffunction 
		name="ShortenURL" 
		access="remote" 
		returntype="struct" 
		returnformat="json"
		output="false" 
		hint="I take a URL and shorten it using a third-party URL service.">
		
		<!--- Define arguments. --->
		<cfargument 
			name="Url" 
			type="string" 
			required="true" 
			hint="I am the URL to shorten." 
			/>
		
		<!--- Define the local scope. --->
		<cfset var LOCAL = {} />
		
		<!--- Create a new response. --->
		<cfset LOCAL.Response = NewAPIResponse() />
		
		<cftry>
		
			<!--- Shorten the URL. --->
			<cfset LOCAL.Response.Data = VARIABLES.Factory.Get( "URLService" ).ShortenURL( ARGUMENTS.Url ) />
		
			<!--- Catch any exceptions. --->
			<cfcatch>
				
				<!--- Update response. --->
				<cfset THIS.HandleAPIError( LOCAL.Response, CFCATCH ) />
			
			</cfcatch>		
		</cftry>
		
		<!--- Return Response. --->
		<cfreturn LOCAL.Response />		
	</cffunction>
	
</cfcomponent>