
<cfcomponent
	extends="BaseService"
	output="false"
	hint="I provide the interface for URL shortening services.">

	
	<cffunction 
		name="Init" 
		access="public" 
		returntype="any" 
		output="false" 
		hint="I return an intialized object.">
		
		<!--- Define arguments. --->
		<cfargument 
			name="Factory" 
			type="any" 
			required="true" 
			hint="I am the applications object factory."
			/>
		
		<!--- Store the factory. --->
		<cfset VARIABLES.Factory = ARGUMENTS.Factory />
		
		<!--- Return This reference. --->
		<cfreturn THIS />
	</cffunction>
	
	
	<cffunction 
		name="ShortenURL" 
		access="public" 
		returntype="string" 
		output="false" 
		hint="I take a URL and shorten it using a third-party URL service.">
		
		<!--- Define arguments. --->
		<cfargument 
			name="Url" 
			type="string" 
			required="true" 
			hint="I am the URL to shorten." 
			/>
			
		<!--- Throw abstract method error. --->
		<cfthrow
			type="KinkyTwits.BaseURLService.ShortenURL.AbstractMethod"
			message="This abstract method cannot be executed."
			detail="You have attempted to execute the abstract method, ShortenURL. This must be overriden by a extending class."
			/>			
	</cffunction>
	
</cfcomponent>