
<cfcomponent
	extends="BaseURLService"
	output="false"
	hint="I shorten URLs using TinyUrl.com.">

	
	<cffunction 
		name="ShortenURL" 
		access="public" 
		returntype="string" 
		output="false" 
		hint="I take a URL and shorten it using a third-party URL service.">
		
		<!--- Define arguments. --->
		<cfargument 
			name="Url" 
			type="string" 
			required="true" 
			hint="I am the URL to shorten." 
			/>
			
		<!--- Define the local scope. --->
		<cfset var LOCAL = {} />
		
		
		<!--- Post the URL to shorten service. --->
		<cfhttp
			url="http://tinyurl.com/create.php"
			method="post"
			useragent="KinkyTwits - Twitter Client"
			result="LOCAL.Post">
		
			<cfhttpparam
				type="formfield"
				name="url"
				value="#ARGUMENTS.Url#"
				/>
				
			<cfhttpparam
				type="formfield"
				name="submit"
				value="Make TinyURL!"
				/>
		</cfhttp>
		
			
		<!--- Check to see if the request was valid. --->
		<cfif NOT FindNoCase( "200", LOCAL.Post.StatusCode )>
		
			<!--- Throw error. --->
			<cfthrow
				type="KinkyTwits.TinyURLService.ShortenURL.FailedRequest"
				message="The request to tinyurl.com failed."
				detail="The request to tinyurl.com failed, returning a status code of, #UCase( LOCAL.Post.StatusCode )#"
				/>
		
		</cfif>
			
			
		<!--- Try to get the shortened URL. --->
		<cfset LOCAL.Matches = REMatchNoCase(
			"http://preview\b.tinyurl\b.com/([\w]+)",
			LOCAL.Post.FileContent
			) />
			
		<!--- Get the URL. --->
		<cfset LOCAL.NewURL = (
			"http://tinyurl.com/" & 
			ListLast( LOCAL.Matches[ 1 ], "/\" ) 
			)/>
		
		<!--- Return the new, short url. --->
		<cfreturn LOCAL.NewURL />
	</cffunction>
	
</cfcomponent>